mod common;
mod error;
mod formats;
mod linker;

use common::{DummyOutput, Storage};
use formats::ElfObject;
use linker::Linker;

fn main() {
    let mut args = std::env::args().peekable();

    // can this miss?
    args.next().unwrap();

    let mut contents: Vec<Storage> = Vec::new();
    let mut linker = Linker::elf();
    let mut output = DummyOutput;

    while args.peek().is_some() {
        let fpath = args.next().expect("Unexpected peek-a-boo");
        let stored = Storage::new(fpath.into());
        contents.push(stored);
    }

    for storage in contents.iter_mut() {
        let relocatable = ElfObject::new(storage).expect("Parsing ELF");
        linker.add_relocatable(Box::new(relocatable));
    }

    linker.link(&mut output).expect("Linking");
}
